import Flutter
import UIKit

public class SwiftMsDspPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "ms_dsp", binaryMessenger: registrar.messenger())
    let instance = SwiftMsDspPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    if(call.method.elementsEqual("process")){
        DispatchQueue.global(qos: .background).async {
            let args = call.arguments as? NSDictionary
            let fftLength = args!["fftLength"] as! Int
            let data = (args!["data"]! as! Array<NSNumber>).map { $0.floatValue }

            if args == nil || fftLength == nil || data == nil {
                result([])
            } else {
                let dsp = DSP(comprimentoFourier: fftLength)
                result(dsp.transformar(signal: data))
            }
        }
    } else {
        result("not")
    }
  }
}
